//+------------------------------------------------------------------+
//|                                              CandleRecognize.mqh |
//|                        Copyright 2015, Pham Thanh Tu 0917388656. |
//|                                 http://laptrinhrobotforex.edu.vn |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Pham Thanh Tu 0917388656."
#property link      "http://laptrinhrobotforex.edu.vn"
#property strict

double Doji_MinLength = 5.0;   //Length of wick from High to Low
double Doji_MaxBody   = 1.5;   //Max body size in pips
double BodyLength     = 5;   //Length of Bar from Open to Close

bool CheckDoji(int Shift)
{    
     double CL  = NormalizeDouble(High[Shift],Digits) - NormalizeDouble(Low[Shift],Digits);
     double BL  = MathAbs(NormalizeDouble(Open[Shift],Digits) - NormalizeDouble(Close[Shift],Digits));
     
     if(CL >= Doji_MinLength*Pips2Double && BL <= Doji_MaxBody*Pips2Double)
     {
          return(1);
     }
     
     return(0);                                  
}

//=====================================================
bool CheckBullish(int Shift)
{
     double O = NormalizeDouble(Open[Shift],Digits);
     double C = NormalizeDouble(Close[Shift],Digits);
     double BL = NormalizeDouble(Close[Shift],Digits) - NormalizeDouble(Open[Shift],Digits);
     
     if((O < C ) && (BL >= (BodyLength*Pips2Double)))  
     {     
          return(1);
     }
 
     return(0);
}

bool CheckBull(int Shift)
{
     double O = NormalizeDouble(Open[Shift],Digits);
     double C = NormalizeDouble(Close[Shift],Digits);
     double BL = NormalizeDouble(Close[Shift],Digits) - NormalizeDouble(Open[Shift],Digits);
     
     if((O < C ) && (BL >= (1*Pips2Double)))  
     {     
          return(1);
     }
 
     return(0);
}
//========================================================
bool CheckBearish(int Shift)
{
     double O = NormalizeDouble(Open[Shift],Digits);
     double C = NormalizeDouble(Close[Shift],Digits);
     double CL = NormalizeDouble(Open[Shift],Digits) - NormalizeDouble(Close[Shift],Digits);
     
     if((O > C)&&(CL >= (BodyLength*Pips2Double))) 
     {
          return(1);
     }
     
     return(0);
}

bool CheckBear(int Shift)
{
     double O = NormalizeDouble(Open[Shift],Digits);
     double C = NormalizeDouble(Close[Shift],Digits);
     double CL = NormalizeDouble(Open[Shift],Digits) - NormalizeDouble(Close[Shift],Digits);
     
     if((O > C)&&(CL >= (1*Pips2Double))) 
     {
          return(1);
     }
     
     return(0);
}
//=========================================================
