
//+------------------------------------------------------------------+
//|                                                    Close_Ord.mqh |
//|                        Copyright 2015, Pham Thanh Tu 0917388656. |
//|                                  http://laptrinhrobotforex.edu.vn|
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Pham Thanh Tu 0917388656."
#property link      "http://laptrinhrobotforex.edu.vn"
#property strict

void CloseAllMarketOrder()
{
     int Ticket;    
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( Mas_Ord_New[i][6] == OP_BUY || Mas_Ord_New[i][6] == OP_SELL )
          {
              Ticket = (int)Mas_Ord_New[i][4];               
              CloseMarketOrder(Ticket);                
          }
     }     
     return;
}



bool CloseMarketOrder(int Ticket)
{
     bool  Ans = false;         
     double ClosePrice = 0.0;
     
     if(OrderSelect(Ticket,SELECT_BY_TICKET))
     {
          while(!Ans)    //Trying closing the order until successfuly
          {
               //-----------------------------------------------------------------------
               if ( OrderType() == OP_BUY )
               {
                    ClosePrice = NormalizeDouble(Bid,Digits);
                    Ans        = OrderClose(Ticket,OrderLots(),ClosePrice,TradeSlippage,Green);
               }     
               if ( OrderType() == OP_SELL )
               {
                    ClosePrice = NormalizeDouble(Ask,Digits);
                    Ans = OrderClose(Ticket,OrderLots(),ClosePrice,TradeSlippage,Red);
               }               
               //----------------------------------------------------------------------
               if(Ans == false)
               {
                    if ( Errors(GetLastError())==false )// If the error is ritical
                    {
                         string Msg = "Error closing order " + IntegerToString(Ticket) + ". Error code " + 
                                      IntegerToString(GetLastError()); 
                         return(false);
                    }
               }
          }
     }
     
     return(Ans);     
}