//+------------------------------------------------------------------+
//|                                  CriterionPatternRecognition.mqh |
//|                        Copyright 2015, Pham Thanh Tu 0917388656. |
//|                                 http://laptrinhrobotforex.edu.vn |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Pham Thanh Tu 0917388656."
#property link      "http://laptrinhrobotforex.edu.vn"
#property strict

extern string Separator_26  = "*** PATTERN RECOGNITION V7 ***"; //Section

extern bool Use_ShootStar_2 = true;
extern bool Use_ShootStar_3 = true;
extern bool Use_ShootStar_4 = true;

extern bool Use_Hammer_2 = true;
extern bool Use_Hammer_3 = true;
extern bool Use_Hammer_4 = true;

extern bool Use_Doji  = true;
extern bool Use_Stars = true;

extern bool Use_DarkCC            = false;
extern bool Use_Piercing_Line     = false;
extern bool Use_Bearish_Engulfing = true;
extern bool Use_Bullish_Engulfing = true;

int  Star_Body_Length = 5;


  
int Criterion()
{    
     double Range, AvgRange;
     int counter, setalert;
     static datetime prevtime = 0;
     int shift;
     int shift1;
     int shift2;
     int shift3;
     int shift4;
     string pattern;
     int setPattern = 0;
     int alert = 0;
     double O, O1, O2, C, C1, C2, C3, L, L1, L2, L3, H, H1, H2, H3;
     double CL, CL1, CL2, BL, BLa, BL90, UW, LW, BodyHigh, BodyLow;
     BodyHigh = 0;
     BodyLow = 0;
     double Doji_Star_Ratio = 0;
     double Doji_MinLength = 0;
     double Star_MinLength = 0;
     int  Pointer_Offset = 0;         // The offset value for the arrow to be located off the candle high or low point.
     int  High_Offset = 0;            // The offset value added to the high arrow pointer for correct plotting of the pattern label.
     int  Offset_ShootStar = 0;       // The offset value of the shooting star above or below the pointer arrow.
     int  Offset_Hammer = 0;          // The offset value of the hammer above or below the pointer arrow.
     int  Offset_Doji = 0;            // The offset value of the doji above or below the pointer arrow.
     int  Offset_Star = 0;            // The offset value of the star above or below the pointer arrow.
     int  Offset_Piercing_Line = 0;   // The offset value of the piercing line above or below the pointer arrow.
     int  Offset_DarkCC = 0;          // The offset value of the dark cloud cover above or below the pointer arrow.
     int  Offset_Bullish_Engulfing = 0;
     int  Offset_Bearish_Engulfing = 0;
     int  IncOffset = 0;              // The offset value that is added to a cummaltive offset value for each pass through the routine so any 
                                    // additional candle patterns that are also met, the label will print above the previous label. 
     double Piercing_Line_Ratio = 0;      
     int Piercing_Candle_Length = 0;  
     int Engulfing_Length = 0;
     double Candle_WickBody_Percent = 0;
     int CandleLength = 0;      
         
     
     if(prevtime == Time[0]) {
      return(0);
     }
     prevtime = Time[0];
   
     Doji_Star_Ratio = 0;
     Piercing_Line_Ratio = 0.5;
     Piercing_Candle_Length = 10;
     Engulfing_Length = 25;
     Candle_WickBody_Percent = 0.9;
     CandleLength = 12;
     Pointer_Offset = 9;
     High_Offset = 20;
     Offset_Hammer = 8;
     Offset_ShootStar = 8;
     Offset_Doji = 8;
     Offset_Star = 8;
     Offset_Piercing_Line = 8;
     Offset_DarkCC = 8;
     Offset_Bearish_Engulfing = 8;
     Offset_Bullish_Engulfing = 8;
     IncOffset = 18;
   
     for (shift = 0; shift < 1; shift++) 
     {
           setalert = 0;
           counter=shift;
           Range=0;
           AvgRange=0;
           for (counter=shift ;counter<=shift+9;counter++) {
              AvgRange=AvgRange+MathAbs(NormalizeDouble(High[counter],RoundTo)-NormalizeDouble(Low[counter],RoundTo));
           }
           Range=AvgRange/10;
           shift1 = shift + 1;
           shift2 = shift + 2;
           shift3 = shift + 3;
           shift4 = shift + 4;      
           
           O = NormalizeDouble(Open[shift1],RoundTo);
           O1 = NormalizeDouble(Open[shift2],RoundTo);
           O2 = NormalizeDouble(Open[shift3],RoundTo);
           H = NormalizeDouble(High[shift1],RoundTo);
           H1 = NormalizeDouble(High[shift2],RoundTo);
           H2 = NormalizeDouble(High[shift3],RoundTo);
           H3 = NormalizeDouble(High[shift4],RoundTo);
           L = NormalizeDouble(Low[shift1],RoundTo);
           L1 = NormalizeDouble(Low[shift2],RoundTo);
           L2 = NormalizeDouble(Low[shift3],RoundTo);
           L3 = NormalizeDouble(Low[shift4],RoundTo);
           C = NormalizeDouble(Close[shift1],RoundTo);
           C1 = NormalizeDouble(Close[shift2],RoundTo);
           C2 = NormalizeDouble(Close[shift3],RoundTo);
           C3 = NormalizeDouble(Close[shift4],RoundTo);
           if(MathAbs(H-L)<1*Pip) continue;
           if(MathAbs(H1-L1)<1*Pip) continue;
           if(MathAbs(H2-L2)<1*Pip) continue;
           if(MathAbs(H3-L3)<1*Pip) continue;
           if (O>C) {
              BodyHigh = O;
              BodyLow = C;  }
           else {
              BodyHigh = C;
              BodyLow = O; }
           CL = NormalizeDouble(High[shift1],RoundTo)-NormalizeDouble(Low[shift1],RoundTo);
           CL1 = NormalizeDouble(High[shift2],RoundTo)-NormalizeDouble(Low[shift2],RoundTo);
           CL2 = NormalizeDouble(High[shift3],RoundTo)-NormalizeDouble(Low[shift3],RoundTo);
           BL = NormalizeDouble(Open[shift1],RoundTo)-NormalizeDouble(Close[shift1],RoundTo);
           UW = NormalizeDouble(High[shift1],RoundTo)-BodyHigh;
           LW = BodyLow-NormalizeDouble(Low[shift1],RoundTo);
           BLa = MathAbs(BL);
           BL90 = BLa*Candle_WickBody_Percent;
                 
              
          // Bearish Patterns  
      
           // Check for Bearish Shooting ShootStar
           if ((H>=H1)&&(H>H2)&&(H>H3))  {
              if (((UW/2)>LW)&&(UW>(2*BL90))&&(CL>=(CandleLength*Pip))&&(O!=C)&&((UW/3)<=LW)&&((UW/4)<=LW)/*&&(L>L1)&&(L>L2)*/)  {
     
              if (Use_ShootStar_2) {
              if (setalert == 0) {
                 pattern  = "SS2";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Bearish Shooting ShootStar
           if ((H>=H1)&&(H>H2)&&(H>H3))  {
              if (((UW/3)>LW)&&(UW>(2*BL90))&&(CL>=(CandleLength*Pip))&&(O!=C)&&((UW/4)<=LW)/*&&(L>L1)&&(L>L2)*/)  {
     
              if (Use_ShootStar_3) {
              if (setalert == 0) {
                 pattern  = "SS3";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Bearish Shooting ShootStar
           if ((H>=H1)&&(H>H2)&&(H>H3))  {
              if (((UW/4)>LW)&&(UW>(2*BL90))&&(CL>=(CandleLength*Pip))&&(O!=C)/*&&(L>L1)&&(L>L2)*/)  {
              
              if (Use_ShootStar_4) {
              if (setalert == 0) {
                 pattern  = "SS4";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Evening Star pattern
           if ((H>=H1)&&(H1>H2)&&(H1>H3))  {
              if (/*(L>O1)&&*/(BLa<(Star_Body_Length*Pip))&&(C2>O2)&&(!O==C)&&((C2-O2)/(/*0.001+*/H2-L2)>Doji_Star_Ratio)/*&&(C2<O1)*/&&(C1>O1)/*&&((H1-L1)>(3*(C1-O1)))*/&&(O>C)&&(CL>=(Star_MinLength*Pip))){
     
              if (Use_Stars) {
              if (setalert == 0) {
                 pattern  = "E_Star";
                 setalert = 1;
              }
              }
              }
           }  
           
           // Check for Evening Doji Star pattern
           if ((H>=H1)&&(H1>H2)&&(H1>H3))  {
              if (/*(L>O1)&&*/(O==C)&&((C2>O2)&&(C2-O2)/(/*0.001+*/H2-L2)>Doji_Star_Ratio)/*&&(C2<O1)*/&&(C1>O1)/*&&((H1-L1)>(3*(C1-O1)))*/&&(CL>=(Doji_MinLength*Pip))) {
     
              if (Use_Doji) {
              if (setalert == 0) {
                 pattern  = "E_Doji";
                 setalert = 1;
              }
              }
              }
           } 
           
           // Check for a Dark Cloud Cover pattern
           if ((C1>O1)&&(((C1+O1)/2)>C)&&(O>C)/*&&(O>C1)*/&&(C>O1)&&((O-C)/(/*0.001+*/(H-L))>Piercing_Line_Ratio)&&((CL>=Piercing_Candle_Length*Pip))) {
     
              if (Use_DarkCC) {
              if (setalert == 0) {
                 pattern  = "DCC";
                 setalert = 1;
              }
              }
           }
     
           // Check for Bearish Engulfing pattern
           if ((C1>O1)&&(O>C)&&(O>=C1)&&(O1>=C)&&((O-C)>(C1-O1))&&(CL>=(Engulfing_Length*Pip))) {
     
              if (Use_Bearish_Engulfing) {
              if (setalert == 0) {
                 pattern  = "S_E";
                 setalert = 1;
              }
              }
           }
      
      // End of Bearish Patterns
      // Bearish Criterion
           if(setalert == 1 && shift == 0)
           {
               setalert = 0;
               return(20);
           }
     
//===========================================================================        
      // Bullish Patterns
        
           // Check for Bullish Hammer   
           if ((L<=L1)&&(L<L2)&&(L<L3))  {
           if (((LW/2)>UW)&&(LW>BL90)&&(CL>=(CandleLength*Pip))&&(O!=C)&&((LW/3)<=UW)&&((LW/4)<=UW)/*&&(H<H1)&&(H<H2)*/)  {
     
              if (Use_Hammer_2) {
              if (setalert == 0) {
                 pattern  = "HMR2";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Bullish Hammer   
           if ((L<=L1)&&(L<L2)&&(L<L3))  {
              if (((LW/3)>UW)&&(LW>BL90)&&(CL>=(CandleLength*Pip))&&(O!=C)&&((LW/4)<=UW)/*&&(H<H1)&&(H<H2)*/)  {
     
              if (Use_Hammer_3) {
              if (setalert == 0) {
                 pattern  = "HMR3";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Bullish Hammer   
           if ((L<=L1)&&(L<L2)&&(L<L3))  {
              if (((LW/4)>UW)&&(LW>BL90)&&(CL>=(CandleLength*Pip))&&(O!=C)/*&&(H<H1)&&(H<H2)*/)  {
     
              if (Use_Hammer_4) {
              if (setalert == 0) {
                 pattern  = "HMR4";
                 setalert = 1;
              }
              }
              }
           }      
     
          // Check for Morning Star
           
           if ((L<=L1)&&(L1<L2)&&(L1<L3))  {
           if (/*(H1<(BL/2))&&*/(BLa<(Star_Body_Length*Pip))&&(!O==C)&&((O2>C2)&&((O2-C2)/(/*0.001+*/H2-L2)>Doji_Star_Ratio))/*&&(C2>O1)*/&&(O1>C1)/*&&((H1-L1)>(3*(C1-O1)))*/&&(C>O)&&(CL>=(Star_MinLength*Pip))) {
     
              if (Use_Stars) {
              if (shift == 0) {
                 pattern="M_Star";
                 setalert = 1;
              }
              }
              }
           }
     
           // Check for Morning Doji Star
           
           if ((L<=L1)&&(L1<L2)&&(L1<L3))  {
           if (/*(H1<(BL/2))&&*/(O==C)&&((O2>C2)&&((O2-C2)/(/*0.001+*/H2-L2)>Doji_Star_Ratio))/*&&(C2>O1)*/&&(O1>C1)/*&&((H1-L1)>(3*(C1-O1)))*/&&(CL>=(Doji_MinLength*Pip))) {
     
              if (Use_Doji) {
              if (shift == 0) {
                 pattern  = "M_Doji";
                 setalert = 1;
              }
              }
              }
           }
           
           // Check for Piercing Line pattern
           
           if ((C1<O1)&&(((O1+C1)/2)<C)&&(O<C)/*&&(O<C1)*//*&&(C<O1)*/&&((C-O)/(/*0.001+*/(H-L))>Piercing_Line_Ratio)&&(CL>=(Piercing_Candle_Length*Pip))) {
     
              if (Use_Piercing_Line) {
              if (shift == 0) {
                 pattern="P_L";
                 setalert = 1;
              }
              }
           }   
     
           // Check for Bullish Engulfing pattern
           
           if ((O1>C1)&&(C>O)&&(C>=O1)&&(C1>=O)&&((C-O)>(O1-C1))&&(CL>=(Engulfing_Length*Pip))) {
     
              if (Use_Bullish_Engulfing) {
              if (shift == 0) {
                 pattern  = "L_E";
                 setalert = 1;
              }
              }
           }
           
      // End of Bullish Patterns    
      // Bullist criterion      
           if(setalert == 1 && shift == 0)
           {
               setalert = 0;   
               return(10);               
           }
     } // End of for loop
      
     return(0);
}


