//+------------------------------------------------------------------+
//|                                                       Donate.mqh |
//|                             Copyright 2014, goldandforex168.com. |
//|                                       http://goldandforex168.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, goldandforex168.com, Pham Thanh Tu 0917.388.656"
#property link      "http://goldandforex168.com"
#property strict
#define PLUS_DONATE  0
#define MINUS_DONATE 0
#define Y_DONATE  40
#define Y_DONATE_SEG  20

#define OBJ_DONATE1 "Obj_Donate1"
#define OBJ_DONATE2 "Obj_Donate2"
#define OBJ_DONATE3 "Obj_Donate3"
#define OBJ_DONATE4 "Obj_Donate4"
#define CRL_DONATE_PROFIT Red
#define CRL_DONATE_LOSE White

void Donate()
{
     if ( PLUS_DONATE == 0 || MINUS_DONATE == 0 ) return; //Disable this function
     
     if ( TradeTotalMarket() == 0 )
     {
         if ( TotalLastProfit() > PLUS_DONATE )
         {
               string Donate1 = "Giao dich dem lai loi nhuan $" + DoubleToString(TotalLastProfit(),2);
               string Donate2 = "Dung quen ghi nhan no luc cua tac gia Robot nay";
               string Donate3 = "Bang cach ung ho 5%-10% so loi nhuan thu duoc";     
               string Donate4 = "Ung ho tac gia tai http://goldandforex168.com/ung-ho";   
               CreateDonateLabels(Donate1,Donate2,Donate3,Donate4,CRL_DONATE_PROFIT);
         }
         else
         if ( TotalLastProfit() < MINUS_DONATE )
         {
               string Donate1 = "Giao dich thua lo $" + DoubleToString(TotalLastProfit(),2);
               string Donate2 = "Hay ghi vao nhat ky giao dich vi sao Robot gap thua lo";
               string Donate3 = "Va thong bao den tac gia bang email tubcymsb@gmail.com";     
               string Donate4 = "";   
               CreateDonateLabels(Donate1,Donate2,Donate3,Donate4,CRL_DONATE_LOSE);
         }
     }
     else
     {
          DeleteDonateLabels();
     }
     
     return;
}

double TotalLastProfit()
{     
     datetime LastFirstOrderOpenTime  = 0;
     string LastFirstAutoComment   = FirstAutoSubComment();
     string LastFirstManualComment = FirstManualSubComment(); 
     //Search in history   
     //---------------------------------------------------- 1 --      
     for ( int i = OrdersHistoryTotal(); i >= 0; i-- )
     {
          if((OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true) && (OrderSymbol()==Symbol()) && (OrderMagicNumber() == MagicNumber) ) 
          {
               if ( (StringFind(OrderComment(),LastFirstAutoComment) > 0) || (StringFind(OrderComment(),LastFirstManualComment) > 0) )
               {
                    if ( IsBuySellOrder(OrderType()) )
                    {
                         LastFirstOrderOpenTime = OrderOpenTime();
                         break;//just select the last one
                    }     
               } 
          }
     } 
     //----------------------------------------------------- 2 --   
     double SumProfitSwap = 0.0;  
     if ( LastFirstOrderOpenTime > 0 )
     {
          for ( int i = OrdersHistoryTotal() - 1; i >= 0; i-- )
          {
               if((OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true) && (OrderSymbol()==Symbol()) && (OrderMagicNumber() == MagicNumber) ) 
               {
                    if ( IsBuySellOrder(OrderType()) && OrderOpenTime() >= LastFirstOrderOpenTime )
                    {
                         SumProfitSwap += OrderProfit() + OrderSwap();
                    }
               }
          }         
     }
     return(SumProfitSwap);
}


void CreateDonateLabels(string Donate1, string Donate2, string Donate3, string Donate4, color Clr)
{
     //Donate1
     if ( ObjectFind(OBJ_DONATE1) < 0 )
     {
          ObjectCreate(OBJ_DONATE1,OBJ_LABEL,0,0,0);
          ObjectSet(OBJ_DONATE1,OBJPROP_CORNER,1);
          ObjectSet(OBJ_DONATE1,OBJPROP_XDISTANCE,70);
          ObjectSet(OBJ_DONATE1,OBJPROP_YDISTANCE,Y_DONATE);
          ObjectSetText(OBJ_DONATE1,"",12,"Tahoma",Clr);     
     }
     ObjectSetText(OBJ_DONATE1,Donate1,12,"Tahoma",Clr);
     //Donate2
     if ( ObjectFind(OBJ_DONATE2) < 0 )
     {
          ObjectCreate(OBJ_DONATE2,OBJ_LABEL,0,0,0);
          ObjectSet(OBJ_DONATE2,OBJPROP_CORNER,1);
          ObjectSet(OBJ_DONATE2,OBJPROP_XDISTANCE,70);
          ObjectSet(OBJ_DONATE2,OBJPROP_YDISTANCE,Y_DONATE + 1*Y_DONATE_SEG);
          ObjectSetText(OBJ_DONATE2,"",12,"Tahoma",Clr);
     }     
     ObjectSetText(OBJ_DONATE2,Donate2,12,"Tahoma",Clr);
     //Donate3
      if ( ObjectFind(OBJ_DONATE3) < 0 ) 
      {
          ObjectCreate(OBJ_DONATE3,OBJ_LABEL,0,0,0);
          ObjectSet(OBJ_DONATE3,OBJPROP_CORNER,1);
          ObjectSet(OBJ_DONATE3,OBJPROP_XDISTANCE,70);
          ObjectSet(OBJ_DONATE3,OBJPROP_YDISTANCE,Y_DONATE + 2*Y_DONATE_SEG);
          ObjectSetText(OBJ_DONATE3,"",12,"Tahoma",Clr);
     }     
     ObjectSetText(OBJ_DONATE3,Donate3,12,"Tahoma",Clr);
     //Donate4
     if ( ObjectFind(OBJ_DONATE4) < 0 ) 
     {
          ObjectCreate(OBJ_DONATE4,OBJ_LABEL,0,0,0);
          ObjectSet(OBJ_DONATE4,OBJPROP_CORNER,1);
          ObjectSet(OBJ_DONATE4,OBJPROP_XDISTANCE,70);
          ObjectSet(OBJ_DONATE4,OBJPROP_YDISTANCE,Y_DONATE + 3*Y_DONATE_SEG);     
          ObjectSetText(OBJ_DONATE4, "",12, "Tahoma", Clr);           
     }
     ObjectSetText(OBJ_DONATE4, Donate4,12, "Tahoma", Clr);  
     //------------------------------
     return;       
}



void DeleteDonateLabels()
{
     if ( ObjectFind(OBJ_DONATE1) >= 0 ) ObjectDelete(OBJ_DONATE1);
     if ( ObjectFind(OBJ_DONATE2) >= 0 ) ObjectDelete(OBJ_DONATE2);
     if ( ObjectFind(OBJ_DONATE3) >= 0 ) ObjectDelete(OBJ_DONATE3);
     if ( ObjectFind(OBJ_DONATE4) >= 0 ) ObjectDelete(OBJ_DONATE4);
     return;
}