#property copyright "Copyright 2015, Pham Thanh Tu. Tel 0917388656"
#property link      "http://laptrinhrobotforex.edu.vn"
//--------------------------------------------------------------------
// Events.mqh
// 
//--------------------------------------------------------------- 1 --
// Event tracking function.
// Global variables:
// Mas_Ord_New[31][12]   The last known array of orders
// Mas_Ord_Old[31][12]   The old array of orders
//--------------------------------------------------------------- 2 --
int Events1()                               // User-defined function  
{
     int Ticket = 0;
     string Msg;
     bool IsDirty = false;;
     bool Conc_Nom_Ord;                     // Matching orders in ..   
                                          //.. the old and the new arrays   
     StopLevel = (int)(MarketInfo(Symbol(),MODE_STOPLEVEL));// Last known                             
     //--------------------------------------------------------------- 4 --
     // Searching for lost, type-changed, partly closed and reopened orders
     for(int old = 1;old <= Mas_Ord_Old[0][0]; old++)// In the array of old orders
     {                                    // Assuming the..
          Conc_Nom_Ord=false;                 // ..orders don't match
          //--------------------------------------------------------- 5 --
          for(int newone = 1; newone <= Mas_Ord_New[0][0]; newone++)//Cycle for the array  ..
          {                                 //..of new orders
               //------------------------------------------------------ 6 --
               if ( Mas_Ord_Old[old][4] == Mas_Ord_New[newone][4] )// Matched number
               {                                      //Order type becomes  ..
                    Conc_Nom_Ord = true;          // The order is found, ..            
                    if ( Mas_Ord_New[newone][6] != Mas_Ord_Old[old][6] )//.. different
                    {
                        IsDirty = true;
                        Msg = " Lots=" + DoubleToString(Mas_Ord_New[newone][5],2);
                    }    
                    break;                        // ..so exiting  ..
               } // .. the internal cycle
               //------------------------------------------------------ 7 --                         
          }
          //--------------------------------------------------------- 8 --      
          if(Conc_Nom_Ord==false)               // If we are here,..
          {                                    // ..it means no order found:(               
               if (Mas_Ord_Old[old][6] == 0)
                   Inform(1, (int)Mas_Ord_Old[old][4]);  // Order Buy closed
               if (Mas_Ord_Old[old][6] == 1)
                   Inform(2, (int)Mas_Ord_Old[old][4]);  // Order Sell closed
               if (Mas_Ord_Old[old][6] > 1)
                   Inform(3,(int)Mas_Ord_Old[old][4]);  // Pending order deleted   
               if(Mas_Ord_Old[old][6] == 0 || Mas_Ord_Old[old][6] == 1)//Order Buy or Sell closed
               {
                    IsDirty = true;
                    Logging(25);           //Logging closed order
                    LoggingFile("Order closed",(int)Mas_Ord_Old[old][4]);//Logging file closed order
                    LoggingEmail(LOG_ORDER_CLOSED,(int)Mas_Ord_Old[old][4]);//Send mail to configed MT4 account
               }              
          }
     }
     //-------------------------------------------------------------- 9 --
     // Search for new orders 
     for(int newone = 1; newone <= Mas_Ord_New[0][0]; newone++)//In the array of new orders
     {
          Conc_Nom_Ord=false;                               //As long as no matches found
          for(int old=1; old <= Mas_Ord_Old[0][0]; old++) //Searching for this order
          {                                   // ..in the array of old orders
               if (Mas_Ord_New[newone][4]==Mas_Ord_Old[old][4])//Matched number..
               {                                          //.. of the order
                    Conc_Nom_Ord=true;            // The order is found, ..
                    break;                       // ..so exiting ..
               }                                // .. the internal cycle
          }
          if(Conc_Nom_Ord == false)            // If no matches found,..
          {                                   // ..the order is new :)
               IsDirty = true;
               Msg = " Lots=" + DoubleToString(Mas_Ord_New[newone][5],2);
               Ticket = (int)Mas_Ord_New[newone][4];
               if ( Mas_Ord_New[newone][6]==0 )
                    Inform(4,Ticket,0,Msg); // Order Buy opened
               if ( Mas_Ord_New[newone][6]==1 )
                    Inform(5,Ticket,0,Msg); // Order Sell opened
               if (Mas_Ord_New[newone][6] > 1)
                    Inform(6,Ticket,0,Msg); // Pending order placed
               if(Mas_Ord_New[newone][6]==0 || Mas_Ord_New[newone][6]==1)
               {
                    Logging(24);            //Logging new open order
                    LoggingFile("Order opened",Ticket);//Logging file closed order
                    LoggingEmail(LOG_ORDER_OPENED,Ticket);   //Send mail to configed MT4 account
               }     
          }
     }
     //-------------------------------------------------------------- 10 --
     //Refresh data if data has changed
     if(IsDirty)
     {
          DrawOrderLine();
     }
     return(0);
}
//-------------------------------------------------------------- 11 --
