//+------------------------------------------------------------------+
//|                                                 HistoryOrder.mqh |
//|                                                    Pham Thanh Tu |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Pham Thanh Tu. Tel 0917388656"
#property link      "http://goldandforex168.com"
#property strict


//Function 
//Take ticket of last opened order in trades, except pending order.
int HistoryLastOrderTicket() 
{
     int Ticket  = -1;
     datetime dt = 0;    
     for (int i = 1; i <= Mas_Ord_His[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( dt < Mas_Ord_His[i][13] ) 
               {
                    Ticket = (int)Mas_Ord_His[i][4];
                    dt     = (datetime)Mas_Ord_His[i][13];               
               }
          }     
     }
     //-------------------------
     return (Ticket);
}




int HistoryPreLastOrderTicket()
{
     int LastTicket    = HistoryLastOrderTicket();
     int PreLastTicket = -1;
     datetime dt = 0;         
     for(int i = 1; i <= Mas_Ord_His[0][0]; i++)
     {
          if(IsBuySellOrder((int)Mas_Ord_His[i][6]) && (Mas_Ord_His[i][4] != LastTicket))
          {
               if(dt < Mas_Ord_His[i][13] )
               {
                    dt            = (datetime)Mas_Ord_His[i][13];
                    PreLastTicket = (int)Mas_Ord_His[i][4];
               }
          }
     }
     //-------------------------
     return (PreLastTicket);
}


double HistoryOrderOpenPrice(int Ticket)
{
     double OpenPrice = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    OpenPrice = Mas_Ord_His[i][1];
                    break;
               }
          }
     }
     return(OpenPrice);
}

double HistoryOrderLots(int Ticket)
{
     double Lots = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    Lots = Mas_Ord_His[i][5];
                    break;
               }
          }
     }
     return(Lots);
}

int HistoryOrderType(int Ticket)
{
     int Type = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    Type = (int)Mas_Ord_His[i][6];
                    break;
               }
          }
     }
     return(Type);
}




double HistoryOrderClosePrice(int Ticket)
{
     double ClosePrice = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    ClosePrice = Mas_Ord_His[i][12];
                    break;
               }
          }
     }
     return(ClosePrice);
}

double HistoryOrderStopLoss(int Ticket)
{
     double pStopLoss = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    pStopLoss = Mas_Ord_His[i][2];
                    break;
               }
          }
     }
     return(pStopLoss);
}

double HistoryOrderTakeProfit(int Ticket)
{
     double dTakeProfit = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if(IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    dTakeProfit = Mas_Ord_His[i][3];
                    break;
               }
          }
     }
     return(dTakeProfit);
}


double HistoryOrderProfitAndSwap(int Ticket)
{
     double dProfitAndSwap = 0.0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    dProfitAndSwap = Mas_Ord_His[i][10] + Mas_Ord_His[i][11];
                    break;
               }
          }
     }
     return(dProfitAndSwap);
}


datetime HistoryOrderCloseTime(int Ticket)
{
     datetime CloseTime = 0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    CloseTime = (datetime)Mas_Ord_His[i][13];
                    break;
               }
          }
     }
     return(CloseTime);
}

datetime HistoryOrderOpenTime(int Ticket)
{
     datetime OpenTime = 0;
     for ( int i = 1; i <= Mas_Ord_His[0][0]; i++ )
     {
          if( IsBuySellOrder((int)Mas_Ord_His[i][6]) )
          {
               if ( Ticket == (int)Mas_Ord_His[i][4] )
               {
                    OpenTime = (datetime)Mas_Ord_His[i][9];
                    break;
               }
          }
     }
     return(OpenTime);
}




//Function 
//Take ticket of last closed order in history.
int LastOrderInHistory(int type = -1) 
{     
     int ticket = -1;
     datetime dt = 0;
     int cnt = HistoryTotal();
     //--------------------------
     int CurrPointer = OrderTicket();
     for (int i = 0; i < cnt; i++)
     {
          if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;

          if (OrderSymbol() != Symbol()) continue;

          if (!(OrderMagicNumber() == MagicNumber)) continue;
    
          if (type != -1 && OrderType() != type) continue;
          
          if ( ! (OrderType() == OP_BUY || OrderType() == OP_SELL) ) continue;          
    
          if (OrderCloseTime() > dt) 
          {
               dt = OrderCloseTime();
               ticket = OrderTicket();
          }
     }
     //-------------------------     
     if(CurrPointer > 0) bool Result = OrderSelect(CurrPointer,SELECT_BY_TICKET);//Restore pointer
     return (ticket);
}