//+------------------------------------------------------------------+
//|                                                   Martingale.mqh |
//|                                   Copyright 2014, Pham Thanh Tu. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015.02.17 Pham Thanh Tu. Tel 0917388656"
#property link      "http://laptrinhrobotforexx.edu.vn"


void CheckMartingale()
{
     //Check max open
     if(MaxOpen() > 0 && TradeTotalMarket() > MaxOpen())
     {
          return;
     }
     //Check
     if(NeedOpenMartingale())
     {                    
          int LastTradeTicket = TradeLastOrderTicket();               
          int Cmd = TradeOrderType(LastTradeTicket);       
          double NewOrderLot   = NewOrderLot(); 
          int NewOrderTicket   = Open_Ord(Cmd,NewOrderLot,NewOrderStopLoss(),NewOrderTakeProfit());
     }
     return;
}

bool NeedOpenMartingale()
{
     if(TradeTotalMarket() < 0) return(false);    
     
     double ToLast = (OperatationMode == 0) ? DistanceToBar0InPoint() : DistanceToLastOrderInPoint();
     if(ToLast > 0) return(false);
     
     if(OperatationMode == 1 || (OperatationMode == 0 && IsNewBar4Martingale()))
     {
          if(ToLast < 0 && MathAbs(ToLast/Pips2Double) > PipRange())
          {          
              return(true);
          }
     }    
    
     return(false);
}


double DistanceToBar0InPoint()
{
     double DistancePoint = 0.0;
     int LastTradeTicket   = TradeLastOrderTicket();
     double LastTradePrice = TradeOrderOpenPrice(LastTradeTicket);
     int LastTradeType     = TradeOrderType(LastTradeTicket);
     
     if(LastTradeType == OP_BUY)
     {
          DistancePoint = NormalizeDouble(Open[0],Digits) - NormalizeDouble(LastTradePrice,Digits);
     }
     
     if(LastTradeType == OP_SELL )
     {
          DistancePoint = NormalizeDouble(LastTradePrice,Digits) - NormalizeDouble(Open[0],Digits);
     }  
     return(DistancePoint);
}


double DistanceToLastOrderInPoint()
{
     double DistancePoint  = 0 ;
     int LastTradeTicket   = TradeLastOrderTicket();
     int LastTradeType     = TradeOrderType(LastTradeTicket);
     double LastTradePrice = TradeOrderOpenPrice(LastTradeTicket);
      
     if(LastTradeType == OP_BUY)
     {
          DistancePoint = NormalizeDouble(Bid,Digits) - NormalizeDouble(LastTradePrice,Digits);
     }
     
     if(LastTradeType == OP_SELL )
     {
          DistancePoint = NormalizeDouble(LastTradePrice,Digits) - NormalizeDouble(Ask,Digits);
     }     
     return(DistancePoint);
}


