#property copyright "Copyright 2014.12.23, Pham Thanh Tu. Tel 0917388656"
#property link      "http://goldandforex168.com"
//--------------------------------------------------------------------
// Open_Ord.mqh
// 
//--------------------------------------------------------------- 1 --
// Runction opening one market pending order depending on last opened order
// Global variable:
// int StopLoss               The value of StopLoss   (amount of points)
// int TakeProfit             The value of TakeProfit (amount of points)
//--------------------------------------------------------------- 2 --


string GlobalBusyOpeningString()
{
     string Busy = "_BUSY_OPENING";
     return(ExpertName() + "_" + Symbol() + Busy);     
}


int Open_Ord(int Tip, double OrdLot,int OrdStopLoss, int OrdTakeProfit)
{
     //------------------------------------------------- 1 --
     string GlobalBusyOpening  = GlobalBusyOpeningString();
     bool BusyOpening  = (bool)GlobalVariableGet(GlobalBusyOpening);
     if(BusyOpening == true)
     {          
          Print("It is busy at opening " + OrderTypeToString(Tip) );
          return(-1);  
     }
     //------------------------------------------------- 2 --
     int    Ticket=-1,                       // Order ticket
            MN;                           // MagicNumber
     double OpenPrice, NewOrdStopLoss, NewOrdTakeProfit;       
     string NewOrdCmt = NewOrderComment(Tip);
     MN = MagicNumber;                  //  MagicNumber
     //------------------------------------------------ 2.1 --
     GlobalVariableSet(GlobalBusyOpening,true);//Set true at global
     while( Ticket < 0 )                    // Until they  ..
     {                                          //.. succeed          
          //-------------------------------------- 2.2 --
          if (Tip == OP_BUY)                                
          {
               OpenPrice        = NormalizeDouble(Ask,Digits);
               NewOrdStopLoss   = OrdStopLoss   == 0 ? 0.0 : NormalizeDouble(Bid - OrdStopLoss*Pips2Double,Digits);
               NewOrdTakeProfit = OrdTakeProfit == 0 ? 0.0 : NormalizeDouble(Ask + OrdTakeProfit*Pips2Double,Digits);   
               Ticket           = OrderSend(Symbol(),0,OrdLot,OpenPrice,TradeSlippage,NewOrdStopLoss,NewOrdTakeProfit,NewOrdCmt,MN,0,Green); 
          }
          //-------------------------------------- 2.3 --
          if ( Tip == OP_SELL )                       
          {
               OpenPrice        = NormalizeDouble(Bid,Digits);
               NewOrdStopLoss   = OrdStopLoss   == 0 ? 0.0 : NormalizeDouble(Ask + OrdStopLoss*Pips2Double,Digits);  
               NewOrdTakeProfit = OrdTakeProfit == 0 ? 0.0 : NormalizeDouble(Bid - OrdTakeProfit*Pips2Double,Digits);   
               Ticket           = OrderSend(Symbol(),1,OrdLot,OpenPrice,TradeSlippage,NewOrdStopLoss,NewOrdTakeProfit,NewOrdCmt,MN,0,Red);
          }
          //------------------------------------- 2.4 --
          if ( Ticket < 0 )                              // Faied :( 
          {                                            // Check for errors:
               if ( Errors(GetLastError()) == false )  // If the error is ritical
               {
                    break;                             // .. then leave.
               }     
          }
          //Terminal();                                  // Order accounting function 
          //Events();                                    // Event tracking
          //------------------------------------- 2.5 --
     }     
     GlobalVariableSet(GlobalBusyOpening,false); //Set false at global
     //------------------------------------------ 3 --
     return(Ticket);// Exit the user-defined function
}


string NewOrderComment(int Tip)
{     
     string OrdCmt =  "TUCMEA ";
     return(OrdCmt);                
}