#property copyright "Copyright 2014, Pham Thanh Tu. Tel 0917388656"
#property link      "http://goldandforex168.com"
//--------------------------------------------------------------------
// Terminal.mqh
// 
//--------------------------------------------------------------- 1 --
// Order accouting function
// Global variables:
// Mas_Ord_New[31][12]   // The latest known order array
// Mas_Ord_Old[31][12];  // .. old order array 
                        // 1st index = order number in the list 
                        // [][0] cannot be detected
                        // [][1] order open price  (abs. price value)
                        // [][2] StopLoss if the orders   (abs. price value)
                        // [][3] TakeProfit of the order (abs. price value)
                        // [][4] order number      
                        // [][5] order volume (abs. price value)
                        // [][6] order type. 0=B,1=S,2=BL,3=SL,4=BS,5=SS
                        // [][7] Order magic number
                        // [][8] 0/1 the fact of avilability of comments
                        // [][9] Order open time
                        // [][10] Order swap
                        // [][11] Order profit              

// Mas_Tip[6]           // Array of the amount 
                        // [] order type: 0=B,1=S,2=BL,3=SL,4=BS,5=SS
                        
//--------------------------------------------------------------- 2 --
int Terminal()
{
     //------------------------------------------------------ 2.1 --
     ArrayCopy(Mas_Ord_Old, Mas_Ord_New);// Saves the preceding history
     //------------------------------------------------------ 2.2 --
     int Qnt=0;                           // Order counter     
     Qnt=0;                              // Zerozie orders counter
     //--------------------------------------------------------------- 3 --
     ArrayInitialize(Mas_Ord_New,0);     // Zerosize the array
     ArrayInitialize(Mas_Tip,    0);     // Zerosize the array
     //--------------------------------------------------------------- 4 --
     for(int i=0; i < OrdersTotal(); i++) // For market and pending orders
     {
          //If there is the next one
          if( (OrderSelect(i,SELECT_BY_POS)==true) && (OrderSymbol()==Symbol()) && (OrderMagicNumber() == MagicNumber) )               //.. and our currentcy pair
          {
               Qnt++;                                   // Amount of orders
               Mas_Ord_New[Qnt][1]=OrderOpenPrice();    // Order open price
               Mas_Ord_New[Qnt][2]=OrderStopLoss();     // SL price
               Mas_Ord_New[Qnt][3]=OrderTakeProfit();   // TP price
               Mas_Ord_New[Qnt][4]=OrderTicket();       // Order number
               Mas_Ord_New[Qnt][5]=OrderLots();         // Amount of lots
               Mas_Tip[OrderType()]++;                  // Amout of orders of the type
               Mas_Ord_New[Qnt][6]=OrderType();         // Order type
               Mas_Ord_New[Qnt][7]=OrderMagicNumber();  // Magic nuumber
               if ( StringFind(OrderComment(),AUTO_COMMENT) > 0 )
               Mas_Ord_New[Qnt][8]=0;                 // automactic comment
               else if ( StringFind(OrderComment(),MANUAL_COMMENT) > 0 )
               Mas_Ord_New[Qnt][8]=1;                 // manual comment               
               Mas_Ord_New[Qnt][9]= (double) OrderOpenTime();   // Time in seconds from 1970
               Mas_Ord_New[Qnt][10]=OrderSwap();      //Current order swap
               Mas_Ord_New[Qnt][11]=OrderProfit();   //Current order profit
               Mas_Ord_New[Qnt][12]= OrderCommission();    //Commission
          }
     }
     Mas_Ord_New[0][0]=Qnt;                         // Amount of orders 
     
     double SumSwap = 0.0, SumProfit = 0.0, SumCommission = 0.0, SumLots = 0.0;
     //Sum swap of buy/sell order
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
               SumSwap += Mas_Ord_New[i][10];
     }
     Mas_Ord_New[0][10] += SumSwap;
     //Sum profit of buy/sell order
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
               SumProfit += Mas_Ord_New[i][11];
     }
     Mas_Ord_New[0][11] = SumProfit;
     //Sum Commission
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
               SumCommission += Mas_Ord_New[i][12];
     }
     Mas_Ord_New[0][12] = SumCommission;
     //Sum total open lots
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
               SumLots += Mas_Ord_New[i][5];
     }
     Mas_Ord_New[0][5] = SumLots;
     //----------------------------------
     return(0);
}



int GetValueFromComment(string StrComment, string Mark)
{
     int Value = 0;
     int MarkLen = StringLen(Mark);
     string sep=" ";                // A separator as a character
     ushort u_sep;                  // The code of the separator character
     string result[];               // An array to get strings
     //--- Get the separator code
     u_sep=StringGetCharacter(sep,0);
     //--- Split the string to substrings
     int k=StringSplit(StrComment,u_sep,result);
     //--- Now output all obtained strings
     if(k>0)
     {
          for(int i=0;i<k;i++)
          {
               if(StringFind(result[i],Mark) >= 0 )
               {
                    string MarkValue = StringSubstr(result[i],MarkLen);
                    Value = StrToInteger(MarkValue);
                    break;
               }
          }
     }
     return(Value);
}