//+------------------------------------------------------------------+
//|                                                   TradeOrder.mqh |
//|                                                    Pham Thanh Tu |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Pham Thanh Tu. Tel 0917388656"
#property link      "http://goldandforex168.com"
#property strict

string OrderTypeToString(int Tip)
{
     switch ( Tip )
     {
          case OP_BUY:
               return("BUY");                  
          case OP_SELL:
               return("SELL");                  
          case OP_BUYLIMIT:
               return("BUY LIMIT");          
          case OP_BUYSTOP:
               return("BUY STOP");           
          case OP_SELLLIMIT:
               return("SELL LIMIT");            
          case OP_SELLSTOP:
               return("SELL STOP");         
     }
     return("Undefined");
}


//Function 
//Return lots of last opening buy/sell order.
double TradeOrderProfit(int Ticket) 
{     
     double Profit = 0.0; 
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    Profit = Mas_Ord_New[i][11];
                    break;
               }     
          }     
     }
     //-------------------------
     return (Profit);
}


double TradeOrderProfitAndSwap(int Ticket) 
{     
     double ProfitSwap = 0.0; 
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    ProfitSwap = Mas_Ord_New[i][11] + Mas_Ord_New[i][10];
                    break;
               }     
          }     
     }
     //-------------------------
     return (ProfitSwap);
}


int TradeOrderType(int Ticket )
{
     int Type = -1;
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]))
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    Type = (int)Mas_Ord_New[i][6];
                    break;
               }
          }
     }
     
     return(Type);
}





//Function 
//Take ticket of pre last opened order in trades, except pending order
int TradePreLastOrderTicket()
{
     int LastTicket = TradeLastOrderTicket();
     int PreLastTicket = -1;
     datetime dt = 0;
         
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) && (Mas_Ord_New[i][4] != LastTicket) )
          {
               if ( dt < Mas_Ord_New[i][9] )
               {
                    PreLastTicket = (int)Mas_Ord_New[i][4];
                    dt            = (datetime)Mas_Ord_New[i][9];        
               }
          }
     }
     //-------------------------
     return (PreLastTicket);
}


double TradeOrderOpenPrice(int Ticket)
{
     double OpenPrice = 0.0;
     for ( int i = 0; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    OpenPrice = Mas_Ord_New[i][1];
                    break;
               }
          }
     }
     return(OpenPrice);
}


double TradeOrderStopLoss(int Ticket)
{
     double OrdStopLoss = 0.0;
     for ( int i = 0; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    OrdStopLoss = Mas_Ord_New[i][2];
                    break;
               }
          }
     }
     return(OrdStopLoss);
}



double TradeOrderTakeProfit(int Ticket)
{
     double OrdTakeProfit = 0.0;
     for ( int i = 0; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][4] == Ticket )
               {
                    OrdTakeProfit = Mas_Ord_New[i][3];
                    break;
               }
          }
     }
     return(OrdTakeProfit);
}


int TradeOrderMagicNumber(int Ticket)
{
     int Number = 0;
     for(int i = 0; i <= Mas_Ord_New[0][0]; i++)
     {
          if(IsBuySellOrder((int)Mas_Ord_New[i][6]))
          {
               if(Mas_Ord_New[i][4] == Ticket)
               {
                    Number = (int)Mas_Ord_New[i][7];
                    break;
               }
          }
     }
     return(Number);
}


//Function 
//Take ticket of last opened order in trades, except pending order.
int TradeLastOrderTicket() 
{
     int Ticket  = -1; //Mas_Ord_New[1][6];
     datetime dt = 0;
    
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( Mas_Ord_New[i][6] == OP_BUY || Mas_Ord_New[i][6] == OP_SELL )
          {
               if ( dt < Mas_Ord_New[i][9] ) 
               {
                    Ticket = (int)Mas_Ord_New[i][4];
                    dt     = (datetime)Mas_Ord_New[i][9];               
               }
          }     
     }
     //-------------------------
     return (Ticket);
}


//Function 
//Take ticket of last opened order in trades of buy or sell group, excepts pending order
int TradeLastOrderTicketOfType(int Tip) 
{
     int Ticket  = -1; //Mas_Ord_New[1][6];
     datetime dt = 0;
    
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) && Mas_Ord_New[i][6] == Tip )
          {
               if ( dt < Mas_Ord_New[i][9] ) 
               {
                    Ticket = (int)Mas_Ord_New[i][4];
                    dt     = (datetime)Mas_Ord_New[i][9];               
               }
          }     
     }
     //-------------------------
     return (Ticket);
}

double TradeOrderLots(int Ticket)
{     
     double Lots = 0.0;
     for( int i=1; i <= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Ticket == Mas_Ord_New[i][4] )
               {
                    Lots = Mas_Ord_New[i][5];
                    break;
               }
          }
     }
     return(Lots);
}

int TradeOrderComment(int Ticket)
{
     int CommentValue = -1;
     for (int i = 1; i <= Mas_Ord_New[0][0]; i++)
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Ticket == Mas_Ord_New[i][4] )
               {
                    CommentValue = (int)Mas_Ord_New[i][8];
                    break;
               }
          }     
     }
     return(CommentValue);
}

string TradeOrderCriterionDesc(int Ticket)
{
     string Desc = "";
     if(OrderSelect(Ticket,SELECT_BY_TICKET))
     {
          string sep=" ";                // A separator as a character
          ushort u_sep;                  // The code of the separator character
          string result[];               // An array to get strings
          //--- Get the separator code
          u_sep=StringGetCharacter(sep,0);
          //--- Split the string to substrings
          int k=StringSplit(OrderComment(),u_sep,result);
          //--- Now output all obtained strings
          if(k > 0)
          {
               Desc = result[k-1];
          }
     }
     return(Desc);
}





bool IsLongPosition(int Tip)
{
     switch(Tip)
     {
          case OP_BUY       :
          case OP_BUYLIMIT  :
          case OP_BUYSTOP   : return(true);
     }
     return(false);
}

bool IsShortPosition(int Tip)
{
     switch(Tip)
     {
          case OP_SELL       :
          case OP_SELLLIMIT  :
          case OP_SELLSTOP   : return(true);
     }
     return(false);
}


bool IsBuySellOrder(int Tip)
{
     switch(Tip)
     {
          case OP_BUY  :
          case OP_SELL :return(true);
     }
     return(false); 
}


bool IsMarketOrder(int Tip)
{
     switch(Tip)
     {
          case OP_BUY  :
          case OP_SELL :return(true);
     }
     return(false); 
}

