//+------------------------------------------------------------------+
//|                                                     Trailing.mqh |
//|                                                    Pham Thanh Tu |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014.12.26, Pham Thanh Tu. Tel 0917388656"
#property link      "http://goldandforex168.com"
#property strict

#define  clModifyBuy Green
#define  clModifySell Red


bool ModifyStopLoss(double ldStopLoss, color clModify, int Ticket)
{
   bool fm = false;         //   
   int  err;
   int    OrdType       = TradeOrderType(Ticket);
   double OrdOpenPrice  = TradeOrderOpenPrice(Ticket);
   double OrdTakeProfit = TradeOrderTakeProfit(Ticket);
   double OrdStopLoss   = TradeOrderStopLoss(Ticket);   
   
   if (IsTradeAllowed())
   {
     if ( OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES) )
     {     
          fm = OrderModify(Ticket,OrdOpenPrice,ldStopLoss,OrderTakeProfit(),0,clModify);
          if (!fm) 
          {
               err=GetLastError();
               Inform(18,0,0,"Error(" + (string) err + ") modifying order stop loss");
          }
     }     
   }
   return(fm);
}


//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
int ProfitPosition(int Ticket)
{
     double pBid, pAsk;
     double pr=0;
     int    OrdType      = TradeOrderType(Ticket);
     double OrdOpenPrice = TradeOrderOpenPrice(Ticket);
     if (OrdType == OP_BUY) 
     {
          pBid = MarketInfo(NULL, MODE_BID);
          pr = (pBid - OrdOpenPrice)/Pips2Double;
     }
     if (OrdType == OP_SELL) 
     {
          pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
          pr = (OrdOpenPrice - pAsk)/Pips2Double;
     }
     return((int)MathRound(pr));
}


