#property copyright "Copyright 2015.3.16"
#property link      "http://laptrinhrobotforex.edu.vn"
//--------------------------------------------------------------------------------
// Variables.mqh
// 
//--------------------------------------------------------------------------- 1 --
// Description of global variables
// Default: disable change pip range and profit to protect
//--------------------------------------------------------------------------- 1 --
// Description of global variables
// Default: disable change pip range and profit to protect



extern string Separator_1     = "==== Time Filter ===="; //Section

extern int StartHour=0;
extern int StartMinute=0;
extern int EndHour=23;
extern int EndMinute=59;

extern string Separator_2     = "==== Martingale Settings ===="; //Section

input ENUM_OPERATATIONMODE OperatationMode=0;  // Operatation Mode
extern double Mutilplier = 1.7;//Martingale Mutiplier
extern int GridSize=10;//GridSize (In Pip)
extern int MaxMarti=0; // Max Marti (0-Unlimited)

extern string Separator_3     = "==== SL/TP Settings ====";//Section

input ENUM_TPMODE TPMode = 1; //Check Take Profit At
extern double TPinMoney=2.0;//Net TP (money)
extern double SLinMoney=0.0;//Net SL (money)


extern string Separator_4     = "==== Misc Settings ===="; //Section

extern double LotSize=0.01;//Init Lot Size
extern int Slippage=2;//Slippage (In Pip)
extern int MagicNumber=2020;//Magic Number

//----------------------------------------------------------------
bool Logging_DisableBuySell     = true;
bool Logging_PipRangeHistory    = false;
bool Logging_PipRangeSpace      = true;
bool Logging_OpenOrder          = true;
bool Logging_CloseOrder         = true;
bool Logging_ReachedMax         = true;
bool Logging_Criterion          = false;
//----------------------------------------------------------------

#define AUTO_COMMENT          "AUT"
#define MANUAL_COMMENT        "MAN"
#define TAKEPROFIT_COMMENT    "TP"
#define STOPLOSS_COMMENT      "SL"

#define LOG_ORDER_OPENED          "Opened Succesfully"
#define LOG_ORDER_CLOSED          "Closed Succesfully"

int 
     Mas_Tip[6];       // Order type array[] Ordery type: 0=B,1=S,2=BL,3=SL,4=BS,5=SS                      
double
     Mas_Ord_New[20][14], // Current order array ..
     Mas_Ord_Old[20][14]; // .. old order array 
                        // 1st index = order number in the list 
                        // [][0] cannot be detected
                        // [][1] order open price  (abs. price value)
                        // [][2] StopLoss if the orders   (abs. price value)
                        // [][3] TakeProfit of the order (abs. price value)
                        // [][4] order number      
                        // [][5] order volume (abs. price value)
                        // [][6] order type. 0=B,1=S,2=BL,3=SL,4=BS,5=SS
                        // [][7] Order magic number
                        // [][8] 0/1 the fact of avilability of comments
                        // [][9] Order Open Time, Time of order opened  
                        // [][10] Order swap
                        // [][11] Order profit   
                        // [][12] Commission
//--------------------------------------------------------------- 3 --

int     TradeSlippage;
int     Pips2Points;    // slippage  3 pips    3=points    30=points
double  Pips2Double;    // Stoploss 15 pips    0.015      0.0150
double  MinLot;
int     StopLevel;

double Pip;


//-------------------------- END OF VARIABLES ------------------------------     

void SetVariables()
{
   //--------------------------------- 1 --
   //Pip and point
   if (Digits % 2 == 1)
   {
      Pips2Double   = Point*10; 
      Pips2Points   = 10;
   } 
   else
   {    
      Pips2Double  = Point;
      Pips2Points  =  1;
   }
   //---------------------------------- 2 --
   //StopLevel
   StopLevel = (int)MarketInfo(Symbol(),MODE_STOPLEVEL);// Last known
   //Slippage
   TradeSlippage   = Slippage*Pips2Points;
   MinLot          = MarketInfo(Symbol(),MODE_MINLOT);
   return;
}


string FirstAutoSubComment()
{
     string cmt = AUTO_COMMENT    + "1";
     return(cmt);
}

string FirstManualSubComment()
{
     string cmt = MANUAL_COMMENT  + "1";
     return(cmt);
}


int TradeTotalMarket(int Tip = -1)
{
     int Total = 0, Type = -1;
     
     for ( int i = 1; i <= Mas_Ord_New[0][0]; i++ )
     {
          Type = (int)Mas_Ord_New[i][6];
          if ( IsBuySellOrder(Type) )
          {
               if ( Tip == -1 )   Total++;
               if ( Type == Tip ) Total++;
          }
     }
          
     return(Total);
}


double TotalNetProfit()
{
     return(Mas_Ord_New[0][10] + Mas_Ord_New[0][11] + Mas_Ord_New[0][12]);
}



double TotalBuyingLot()
{
     double TotalLot = 0.0;
     for ( int i = 1; i<= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][6] == OP_BUY )
                    TotalLot += Mas_Ord_New[i][5];
          }
     }
     return(TotalLot);
}

double TotalSellingLot()
{
     double TotalLot = 0.0;
     for ( int i = 1; i<= Mas_Ord_New[0][0]; i++ )
     {
          if ( IsBuySellOrder((int)Mas_Ord_New[i][6]) )
          {
               if ( Mas_Ord_New[i][6] == OP_SELL )
                    TotalLot += Mas_Ord_New[i][5];
          }
     }
     return(TotalLot);
}


string ExpertName()
{
     return("TU_CandleMariEA 1.0");
}

string ExpertDescription()
{
     return("TU_CandleMariEA");
}

int PipRange()
{
     return(GridSize);
}


int NewOrderTakeProfit()
{
     return(0);
}


int NewOrderStopLoss()
{    
     return(0);
}


int MaxOpen()
{
     return(MaxMarti);
}

double NewOrderLot()
{
     if(TradeTotalMarket() > 1)
     {
          int lotdecimal = 2;
          int NumOfTrades = TradeTotalMarket(OP_BUY) + TradeTotalMarket(OP_SELL);
          double Lots      = NormalizeDouble(LotSize * MathPow(Mutilplier, NumOfTrades), lotdecimal);
          return(Lots);
     }
     return(LotSize);
}

